using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PhoenixDLL.Class.Managers;
using Utils.Log;
using PhoenixDLL.GUI.Managers.Root;

namespace PhoenixDLL.GUI.Managers
{
    /// <summary>
    /// Gestionnaire de mdicaments
    /// </summary>
    public partial class fr_DrugsManager : fr_RootManager
    {
        #region Variables
        /// <summary>
        /// Gestionnaire de mdicaments
        /// </summary>
        private DrugsManager vDrugsManager = new DrugsManager();
        #endregion

        #region Constructeur
        /// <summary>
        /// Constructeur
        /// </summary>
        public fr_DrugsManager()
        {
            InitializeComponent();
        }
        #endregion

        #region Mthodes
        /// <summary>
        /// Traitement sur un clique sur OK
        /// </summary>
        protected override void ProcessOK()
        {
            try
            {
                switch (vUse)
                {
                    case Use.Update:
                        vDrugsManager.Update();
                        this.Close();
                        break;
                    case Use.Delete:
                        vDrugsManager.Delete();
                        this.Close();
                        break;
                    case Use.Add:
                        if (vDrugsManager.DrugsType.ID < 1)
                        {
                            MessageBox.Show("Veuillez choisir un type pour ce mdicament!",
                                "Information", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                            return;
                        }
                        vDrugsManager.Add();
                        this.Close();
                        break;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Une erreur est survenue!\r\n"
                    + ex.Message, "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                Log.GetInstance().Write(ex.Message, "fr_DrugsManager.ProcessOK()", LogType.Erreur);
                this.Close();
            }            
        }
        #endregion

        #region Accesseurs
        /// <summary>
        /// Retourne ou initialise le manager de mdicaments
        /// </summary>
        public DrugsManager Manager
        {
            get { return vDrugsManager; }
            set
            {
                vDrugsManager = value;
                pg_PropertyGrid.SelectedObject = vDrugsManager;
            }
        }
        #endregion
    }
}

